<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Text Property</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Text Property<br/>
<small>
[<a class="el" href="group__m17nCore.html">CORE API</a>]</small>
</h1>
<p>Function to handle text properties.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gaada4c814dbc5172e58c24a2aad6787d4">MTextPropSerializeFunc</a> )(void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of serializer functions.  <a href="#gaada4c814dbc5172e58c24a2aad6787d4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef void *(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga61ac57ea1f208ae1ee78f7b64fbf38b1">MTextPropDeserializeFunc</a> )(<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of deserializer functions.  <a href="#ga61ac57ea1f208ae1ee78f7b64fbf38b1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of text properties.  <a href="#ga3ca6e980d54288001b0a896c49a689ce"></a><br/></td></tr>
<tr><td colspan="2"><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga5b33fa00eaa5a08531732df88a24a9a9">MTextPropertyControl</a> { <br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a12cbd712f80075cc687d5f901ea47c5a">MTEXTPROP_FRONT_STICKY</a> =  0x01, 
<br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a3acb63f56ef54332511eded4e7d6fb6d">MTEXTPROP_REAR_STICKY</a> =  0x02, 
<br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a82c87bdf72b1a175e58908c9279af7be">MTEXTPROP_VOLATILE_WEAK</a> =  0x04, 
<br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a6359a5ae58e92c371f08539c7559c16e">MTEXTPROP_VOLATILE_STRONG</a> =  0x08, 
<br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a9cf177c28dc6f80836f805d0825e1839">MTEXTPROP_NO_MERGE</a> =  0x10, 
<br/>
&nbsp;&nbsp;<a class="el" href="group__m17nTextProperty.html#gga5b33fa00eaa5a08531732df88a24a9a9a9c1f2de18de1e6e9823ef7943e2670e9">MTEXTPROP_CONTROL_MAX</a> =  0x1F
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><p>Flag bits to control text property. </p>
 <a href="group__m17nTextProperty.html#ga5b33fa00eaa5a08531732df88a24a9a9">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c">mtext_get_prop</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the value of the topmost text property.  <a href="#ga3b37b8a451e0618b8393402a88123a5c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf">mtext_get_prop_values</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void **values, int num)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get multiple values of a text property.  <a href="#ga7649d0794df9829ece537861eaff87cf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga0072b994eed0eefd66be053484bf1dc9">mtext_get_prop_keys</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> **keys)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a list of text property keys at a position of an M-text.  <a href="#ga0072b994eed0eefd66be053484bf1dc9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f">mtext_put_prop</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set a text property.  <a href="#ga0ebfee8b550cc5ccaefd6f091fc5695f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787">mtext_put_prop_values</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void **values, int num)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set multiple text properties with the same key.  <a href="#gaa027998420efcfa94b5e91140ea08787"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65">mtext_push_prop</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Push a text property.  <a href="#ga1525f066294eb2645b5c2e41b68e0a65"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5">mtext_pop_prop</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pop a text property.  <a href="#gaa63265ad53bc7fddf62631fa8f3fb0d5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4">mtext_prop_range</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, int pos, int *from, int *to, int deeper)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Find the range where the value of a text property is the same.  <a href="#gae023984f61bfb4198f9ac70350bdb8d4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gad94bf3a0a1384c2a7b5a759c7a93b88b">mtext_property</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val, int control_bits)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a text property.  <a href="#gad94bf3a0a1384c2a7b5a759c7a93b88b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga0c227387edfda07824c6822e9e27435a">mtext_property_mtext</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the M-text of a text property.  <a href="#ga0c227387edfda07824c6822e9e27435a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga1faaffce04424f85f5a78461ad9bfaec">mtext_property_key</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the key of a text property.  <a href="#ga1faaffce04424f85f5a78461ad9bfaec"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga5d3bbf3edab14ee3d26be9158b41bb31">mtext_property_value</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the value of a text property.  <a href="#ga5d3bbf3edab14ee3d26be9158b41bb31"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gac03079958c4de03ebc72766cf27bca25">mtext_property_start</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the start position of a text property.  <a href="#gac03079958c4de03ebc72766cf27bca25"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga550abffc59e78bfa137e44469af2f102">mtext_property_end</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the end position of a text property.  <a href="#ga550abffc59e78bfa137e44469af2f102"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga857bf31decfcc6063f33183373901c3e">mtext_get_property</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the topmost text property.  <a href="#ga857bf31decfcc6063f33183373901c3e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#gaa08e0d0924274c37f28fca9afb0d7d58">mtext_get_properties</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> **props, int num)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get multiple text properties.  <a href="#gaa08e0d0924274c37f28fca9afb0d7d58"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga80333ace7a285d5a09ed0575cda75d84">mtext_attach_property</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Attach a text property to an M-text.  <a href="#ga80333ace7a285d5a09ed0575cda75d84"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga6e4c9702d75cde94c6bfc9f44ea13258">mtext_detach_property</a> (<a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Detach a text property from an M-text.  <a href="#ga6e4c9702d75cde94c6bfc9f44ea13258"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga1db069da9e058d3129a6469f4d359c0f">mtext_push_property</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *prop)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Push a text property onto an M-text.  <a href="#ga1db069da9e058d3129a6469f4d359c0f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e">mtext_serialize</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *property_list)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Serialize text properties in an M-text.  <a href="#ga4830a8a120aeed2185d6da8fd2daa05e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf">mtext_deserialize</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Deserialize text properties in an M-text.  <a href="#ga82e022961a26f82ddf580782a50d94bf"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735">Mtext_prop_serializer</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for specifying serializer functions.  <a href="#ga759ba1a6ac36d9847bc6b4d431ae3735"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077">Mtext_prop_deserializer</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for specifying deserializer functions.  <a href="#ga97f4c75b4ebf8ff252948dbf068bc077"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Function to handle text properties. </p>
<p>Each character in an M-text can have properties called <em>text</em> <em>properties</em>. Text properties store various kinds of information attached to parts of an M-text to provide application programs with a unified view of those information. As rich information can be stored in M-texts in the form of text properties, functions in application programs can be simple.</p>
<p>A text property consists of a <em>key</em> and <em>values</em>, where key is a symbol and values are anything that can be cast to <code>(void *) </code>. Unlike other types of properties, a text property can have multiple values. "The text property whose key is K" may be shortened to "K property". </p>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="gaada4c814dbc5172e58c24a2aad6787d4"></a><!-- doxytag: member="m17n&#45;core.h::MTextPropSerializeFunc" ref="gaada4c814dbc5172e58c24a2aad6787d4" args=")(void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>*(* <a class="el" href="group__m17nTextProperty.html#gaada4c814dbc5172e58c24a2aad6787d4">MTextPropSerializeFunc</a>)(void *val)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of serializer functions. </p>
<p>This is the type of serializer functions. If the key of a symbol property is <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735" title="Symbol for specifying serializer functions.">Mtext_prop_serializer</a>, the value must be of this type.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a>, <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735" title="Symbol for specifying serializer functions.">Mtext_prop_serializer</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga61ac57ea1f208ae1ee78f7b64fbf38b1"></a><!-- doxytag: member="m17n&#45;core.h::MTextPropDeserializeFunc" ref="ga61ac57ea1f208ae1ee78f7b64fbf38b1" args=")(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void*(* <a class="el" href="group__m17nTextProperty.html#ga61ac57ea1f208ae1ee78f7b64fbf38b1">MTextPropDeserializeFunc</a>)(<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of deserializer functions. </p>
<p>This is the type of deserializer functions. If the key of a symbol property is <a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077" title="Symbol for specifying deserializer functions.">Mtext_prop_deserializer</a>, the value must be of this type.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a>, <a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077" title="Symbol for specifying deserializer functions.">Mtext_prop_deserializer</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga3ca6e980d54288001b0a896c49a689ce"></a><!-- doxytag: member="m17n&#45;core.h::MTextProperty" ref="ga3ca6e980d54288001b0a896c49a689ce" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of text properties. </p>
<p>The type <a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce" title="Type of text properties.">MTextProperty</a> is for a <em>text</em> <em>property</em> objects. Its internal structure is concealed from application programs. </p>

</div>
</div>
<hr/><h2>Enumeration Type Documentation</h2>
<a class="anchor" id="ga5b33fa00eaa5a08531732df88a24a9a9"></a><!-- doxytag: member="m17n&#45;core.h::MTextPropertyControl" ref="ga5b33fa00eaa5a08531732df88a24a9a9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__m17nTextProperty.html#ga5b33fa00eaa5a08531732df88a24a9a9">MTextPropertyControl</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag bits to control text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gad94bf3a0a1384c2a7b5a759c7a93b88b" title="Create a text property.">mtext_property()</a> function accepts logical OR of these flag bits as an argument. They control the behaviour of the created text property as described in the documentation of each flag bit. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a12cbd712f80075cc687d5f901ea47c5a"></a><!-- doxytag: member="MTEXTPROP_FRONT_STICKY" ref="gga5b33fa00eaa5a08531732df88a24a9a9a12cbd712f80075cc687d5f901ea47c5a" args="" -->MTEXTPROP_FRONT_STICKY</em>&nbsp;</td><td>
<p>If this flag bit is on, an M-text inserted at the start position or at the middle of the text property inherits the text property. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a3acb63f56ef54332511eded4e7d6fb6d"></a><!-- doxytag: member="MTEXTPROP_REAR_STICKY" ref="gga5b33fa00eaa5a08531732df88a24a9a9a3acb63f56ef54332511eded4e7d6fb6d" args="" -->MTEXTPROP_REAR_STICKY</em>&nbsp;</td><td>
<p>If this flag bit is on, an M-text inserted at the end position or at the middle of the text property inherits the text property. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a82c87bdf72b1a175e58908c9279af7be"></a><!-- doxytag: member="MTEXTPROP_VOLATILE_WEAK" ref="gga5b33fa00eaa5a08531732df88a24a9a9a82c87bdf72b1a175e58908c9279af7be" args="" -->MTEXTPROP_VOLATILE_WEAK</em>&nbsp;</td><td>
<p>If this flag bit is on, the text property is removed if a text in its region is modified. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a6359a5ae58e92c371f08539c7559c16e"></a><!-- doxytag: member="MTEXTPROP_VOLATILE_STRONG" ref="gga5b33fa00eaa5a08531732df88a24a9a9a6359a5ae58e92c371f08539c7559c16e" args="" -->MTEXTPROP_VOLATILE_STRONG</em>&nbsp;</td><td>
<p>If this flag bit is on, the text property is removed if a text or the other text property in its region is modified. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a9cf177c28dc6f80836f805d0825e1839"></a><!-- doxytag: member="MTEXTPROP_NO_MERGE" ref="gga5b33fa00eaa5a08531732df88a24a9a9a9cf177c28dc6f80836f805d0825e1839" args="" -->MTEXTPROP_NO_MERGE</em>&nbsp;</td><td>
<p>If this flag bit is on, the text property is not automatically merged with the others. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b33fa00eaa5a08531732df88a24a9a9a9c1f2de18de1e6e9823ef7943e2670e9"></a><!-- doxytag: member="MTEXTPROP_CONTROL_MAX" ref="gga5b33fa00eaa5a08531732df88a24a9a9a9c1f2de18de1e6e9823ef7943e2670e9" args="" -->MTEXTPROP_CONTROL_MAX</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga3b37b8a451e0618b8393402a88123a5c"></a><!-- doxytag: member="textprop.c::mtext_get_prop" ref="ga3b37b8a451e0618b8393402a88123a5c" args="(MText *mt, int pos, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mtext_get_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of the topmost text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a> function searches the character at <b>pos</b> in M-text <b>mt</b> for the text property whose key is <b>key</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If a text property is found, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a> returns the value of the property. If the property has multiple values, it returns the topmost one. If no such property is found, it returns <code>NULL</code> without changing the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<p>If an error is detected, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a> returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</p>
<dl class="note"><dt><b>Note:</b></dt><dd>If <code>NULL</code> is returned without an error, there are two possibilities:</dd></dl>
<ul>
<li>the character at <b>pos</b> does not have a property whose key is <b>key</b>, or</li>
</ul>
<ul>
<li>the character does have such a property and its value is <code>NULL</code>.</li>
</ul>
<p>If you need to distinguish these two cases, use the <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a> function instead.</p>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga7649d0794df9829ece537861eaff87cf"></a><!-- doxytag: member="textprop.c::mtext_get_prop_values" ref="ga7649d0794df9829ece537861eaff87cf" args="(MText *mt, int pos, MSymbol key, void **values, int num)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_get_prop_values </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>values</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>num</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get multiple values of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a> function searches the character at <b>pos</b> in M-text <b>mt</b> for the property whose key is <b>key</b>. If such a property is found, its values are stored in the memory area pointed to by <b>values</b>. <b>num</b> limits the maximum number of stored values.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a> returns the number of actually stored values. If the character at <b>pos</b> does not have a property whose key is <b>key</b>, the return value is 0. If an error is detected, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a> returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga0072b994eed0eefd66be053484bf1dc9"></a><!-- doxytag: member="textprop.c::mtext_get_prop_keys" ref="ga0072b994eed0eefd66be053484bf1dc9" args="(MText *mt, int pos, MSymbol **keys)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_get_prop_keys </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> **&nbsp;</td>
          <td class="paramname"> <em>keys</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a list of text property keys at a position of an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga0072b994eed0eefd66be053484bf1dc9" title="Get a list of text property keys at a position of an M-text.">mtext_get_prop_keys()</a> function creates an array whose elements are the keys of text properties found at position <b>pos</b> in M-text <b>mt</b>, and sets *<b>keys</b> to the address of the created array. The user is responsible to free the memory allocated for the array.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga0072b994eed0eefd66be053484bf1dc9" title="Get a list of text property keys at a position of an M-text.">mtext_get_prop_keys()</a> returns the length of the key list. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga0ebfee8b550cc5ccaefd6f091fc5695f"></a><!-- doxytag: member="textprop.c::mtext_put_prop" ref="ga0ebfee8b550cc5ccaefd6f091fc5695f" args="(MText *mt, int from, int to, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_put_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a> function sets a text property to the characters between <b>from</b> (inclusive) and <b>to</b> (exclusive) in M-text <b>mt</b>. <b>key</b> and <b>val</b> specify the key and the value of the text property. With this function,</p>
<div class="fragment"><pre class="fragment">
                     FROM                   TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;------------------ OLD_VAL --------------------&gt;
</pre></div><p>becomes</p>
<div class="fragment"><pre class="fragment">
                     FROM                   TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;-- OLD_VAL-&gt;&lt;-------- VAL -------&gt;&lt;-- OLD_VAL--&gt;
</pre></div><dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gaa027998420efcfa94b5e91140ea08787"></a><!-- doxytag: member="textprop.c::mtext_put_prop_values" ref="gaa027998420efcfa94b5e91140ea08787" args="(MText *mt, int from, int to, MSymbol key, void **values, int num)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_put_prop_values </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>values</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>num</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set multiple text properties with the same key. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a> function sets a text property to the characters between <b>from</b> (inclusive) and <b>to</b> (exclusive) in M-text <b>mt</b>. <b>key</b> and <b>values</b> specify the key and the values of the text property. <b>num</b> specifies the number of property values to be set.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga1525f066294eb2645b5c2e41b68e0a65"></a><!-- doxytag: member="textprop.c::mtext_push_prop" ref="ga1525f066294eb2645b5c2e41b68e0a65" args="(MText *mt, int from, int to, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_push_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Push a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a> function pushes a text property whose key is <b>key</b> and value is <b>val</b> to the characters between <b>from</b> (inclusive) and <b>to</b> (exclusive) in M-text <b>mt</b>. With this function,</p>
<div class="fragment"><pre class="fragment">
                    FROM                    TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;------------------ OLD_VAL --------------------&gt;
</pre></div><p>becomes</p>
<div class="fragment"><pre class="fragment">
                    FROM                    TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;------------------- OLD_VAL -------------------&gt;
PROP  :               &lt;-------- VAL -------&gt;
</pre></div><dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gaa63265ad53bc7fddf62631fa8f3fb0d5"></a><!-- doxytag: member="textprop.c::mtext_pop_prop" ref="gaa63265ad53bc7fddf62631fa8f3fb0d5" args="(MText *mt, int from, int to, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_pop_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Pop a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a> function removes the topmost text property whose key is <b>key</b> from the characters between <b>from</b> (inclusive) and and <b>to</b> (exclusive) in <b>mt</b>.</p>
<p>This function does nothing if characters in the region have no such text property. With this function,</p>
<div class="fragment"><pre class="fragment">
                    FROM                    TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;------------------ OLD_VAL --------------------&gt;
</pre></div><p>becomes</p>
<div class="fragment"><pre class="fragment">
                    FROM                    TO
M-text: |&lt;------------|-------- MT ---------|------------&gt;|
PROP  :  &lt;--OLD_VAL--&gt;|                     |&lt;--OLD_VAL--&gt;|
</pre></div><dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a> return 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gae023984f61bfb4198f9ac70350bdb8d4"></a><!-- doxytag: member="textprop.c::mtext_prop_range" ref="gae023984f61bfb4198f9ac70350bdb8d4" args="(MText *mt, MSymbol key, int pos, int *from, int *to, int deeper)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_prop_range </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>deeper</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find the range where the value of a text property is the same. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> function investigates the extent where all characters have the same value for a text property. It first finds the value of the property specified by <b>key</b> of the character at <b>pos</b> in M-text <b>mt</b>. Then it checks if adjacent characters have the same value for the property <b>key</b>. The beginning and the end of the found range are stored to the variable pointed to by <b>from</b> and <b>to</b>. The character position stored in <b>from</b> is inclusive but that in <b>to</b> is exclusive; this fashion is compatible with the range specification in the <a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a> function, etc.</p>
<p>If <b>deeper</b> is not 0, not only the topmost but also all the stacked properties whose key is <b>key</b> are compared.</p>
<p>If <b>from</b> is <code>NULL</code>, the beginning of range is not searched for. If <b>to</b> is <code>NULL</code>, the end of range is not searched for.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd></dd></dl>
<p>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#gae023984f61bfb4198f9ac70350bdb8d4" title="Find the range where the value of a text property is the same.">mtext_prop_range()</a> returns the number of values the property <b>key</b> has at pos. Otherwise it returns -1 and assigns an error code to the external variable <code>merror_code</code>.</p>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_RANGE</code>, <code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga0ebfee8b550cc5ccaefd6f091fc5695f" title="Set a text property.">mtext_put_prop()</a>, <a class="el" href="group__m17nTextProperty.html#gaa027998420efcfa94b5e91140ea08787" title="Set multiple text properties with the same key.">mtext_put_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#ga3b37b8a451e0618b8393402a88123a5c" title="Get the value of the topmost text property.">mtext_get_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga7649d0794df9829ece537861eaff87cf" title="Get multiple values of a text property.">mtext_get_prop_values()</a>, <a class="el" href="group__m17nTextProperty.html#gaa63265ad53bc7fddf62631fa8f3fb0d5" title="Pop a text property.">mtext_pop_prop()</a>, <a class="el" href="group__m17nTextProperty.html#ga1525f066294eb2645b5c2e41b68e0a65" title="Push a text property.">mtext_push_prop()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gad94bf3a0a1384c2a7b5a759c7a93b88b"></a><!-- doxytag: member="textprop.c::mtext_property" ref="gad94bf3a0a1384c2a7b5a759c7a93b88b" args="(MSymbol key, void *val, int control_bits)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a>* mtext_property </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>control_bits</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gad94bf3a0a1384c2a7b5a759c7a93b88b" title="Create a text property.">mtext_property()</a> function returns a newly allocated text property whose key is <b>key</b> and value is <b>val</b>. The created text property is not attached to any M-text, i.e. it is detached.</p>
<p><b>control_bits</b> must be 0 or logical OR of <code>enum</code> <code>MTextPropertyControl</code>. </p>

</div>
</div>
<a class="anchor" id="ga0c227387edfda07824c6822e9e27435a"></a><!-- doxytag: member="textprop.c::mtext_property_mtext" ref="ga0c227387edfda07824c6822e9e27435a" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* mtext_property_mtext </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the M-text of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga0c227387edfda07824c6822e9e27435a" title="Return the M-text of a text property.">mtext_property_mtext()</a> function returns the M-text to which text property <b>prop</b> is attached. If <b>prop</b> is currently detached, NULL is returned. </p>

</div>
</div>
<a class="anchor" id="ga1faaffce04424f85f5a78461ad9bfaec"></a><!-- doxytag: member="textprop.c::mtext_property_key" ref="ga1faaffce04424f85f5a78461ad9bfaec" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mtext_property_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the key of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga1faaffce04424f85f5a78461ad9bfaec" title="Return the key of a text property.">mtext_property_key()</a> function returns the key (symbol) of text property <b>prop</b>. </p>

</div>
</div>
<a class="anchor" id="ga5d3bbf3edab14ee3d26be9158b41bb31"></a><!-- doxytag: member="textprop.c::mtext_property_value" ref="ga5d3bbf3edab14ee3d26be9158b41bb31" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mtext_property_value </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the value of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga5d3bbf3edab14ee3d26be9158b41bb31" title="Return the value of a text property.">mtext_property_value()</a> function returns the value of text property <b>prop</b>. </p>

</div>
</div>
<a class="anchor" id="gac03079958c4de03ebc72766cf27bca25"></a><!-- doxytag: member="textprop.c::mtext_property_start" ref="gac03079958c4de03ebc72766cf27bca25" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_property_start </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the start position of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gac03079958c4de03ebc72766cf27bca25" title="Return the start position of a text property.">mtext_property_start()</a> function returns the start position of text property <b>prop</b>. The start position is a character position of an M-text where <b>prop</b> begins. If <b>prop</b> is detached, it returns -1. </p>

</div>
</div>
<a class="anchor" id="ga550abffc59e78bfa137e44469af2f102"></a><!-- doxytag: member="textprop.c::mtext_property_end" ref="ga550abffc59e78bfa137e44469af2f102" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_property_end </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the end position of a text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga550abffc59e78bfa137e44469af2f102" title="Return the end position of a text property.">mtext_property_end()</a> function returns the end position of text property <b>prop</b>. The end position is a character position of an M-text where <b>prop</b> ends. If <b>prop</b> is detached, it returns -1. </p>

</div>
</div>
<a class="anchor" id="ga857bf31decfcc6063f33183373901c3e"></a><!-- doxytag: member="textprop.c::mtext_get_property" ref="ga857bf31decfcc6063f33183373901c3e" args="(MText *mt, int pos, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a>* mtext_get_property </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the topmost text property. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga857bf31decfcc6063f33183373901c3e" title="Get the topmost text property.">mtext_get_property()</a> function searches the character at position <b>pos</b> in M-text <b>mt</b> for a text property whose key is <b>key</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If a text property is found, <a class="el" href="group__m17nTextProperty.html#ga857bf31decfcc6063f33183373901c3e" title="Get the topmost text property.">mtext_get_property()</a> returns it. If there are multiple text properties, it returns the topmost one. If no such property is found, it returns <code>NULL</code> without changing the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<p>If an error is detected, <a class="el" href="group__m17nTextProperty.html#ga857bf31decfcc6063f33183373901c3e" title="Get the topmost text property.">mtext_get_property()</a> returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </p>

</div>
</div>
<a class="anchor" id="gaa08e0d0924274c37f28fca9afb0d7d58"></a><!-- doxytag: member="textprop.c::mtext_get_properties" ref="gaa08e0d0924274c37f28fca9afb0d7d58" args="(MText *mt, int pos, MSymbol key, MTextProperty **props, int num)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_get_properties </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> **&nbsp;</td>
          <td class="paramname"> <em>props</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>num</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get multiple text properties. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#gaa08e0d0924274c37f28fca9afb0d7d58" title="Get multiple text properties.">mtext_get_properties()</a> function searches the character at <b>pos</b> in M-text <b>mt</b> for properties whose key is <b>key</b>. If such properties are found, they are stored in the memory area pointed to by <b>props</b>. <b>num</b> limits the maximum number of stored properties.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#gaa08e0d0924274c37f28fca9afb0d7d58" title="Get multiple text properties.">mtext_get_properties()</a> returns the number of actually stored properties. If the character at <b>pos</b> does not have a property whose key is <b>key</b>, the return value is 0. If an error is detected, <a class="el" href="group__m17nTextProperty.html#gaa08e0d0924274c37f28fca9afb0d7d58" title="Get multiple text properties.">mtext_get_properties()</a> returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga80333ace7a285d5a09ed0575cda75d84"></a><!-- doxytag: member="textprop.c::mtext_attach_property" ref="ga80333ace7a285d5a09ed0575cda75d84" args="(MText *mt, int from, int to, MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_attach_property </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Attach a text property to an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga80333ace7a285d5a09ed0575cda75d84" title="Attach a text property to an M-text.">mtext_attach_property()</a> function attaches text property <b>prop</b> to the range between <b>from</b> and <b>to</b> in M-text <b>mt</b>. If <b>prop</b> is already attached to an M-text, it is detached before attached to <b>mt</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga80333ace7a285d5a09ed0575cda75d84" title="Attach a text property to an M-text.">mtext_attach_property()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga6e4c9702d75cde94c6bfc9f44ea13258"></a><!-- doxytag: member="textprop.c::mtext_detach_property" ref="ga6e4c9702d75cde94c6bfc9f44ea13258" args="(MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_detach_property </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Detach a text property from an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga6e4c9702d75cde94c6bfc9f44ea13258" title="Detach a text property from an M-text.">mtext_detach_property()</a> function makes text property <b>prop</b> detached.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function always returns 0. </dd></dl>

</div>
</div>
<a class="anchor" id="ga1db069da9e058d3129a6469f4d359c0f"></a><!-- doxytag: member="textprop.c::mtext_push_property" ref="ga1db069da9e058d3129a6469f4d359c0f" args="(MText *mt, int from, int to, MTextProperty *prop)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mtext_push_property </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nTextProperty.html#ga3ca6e980d54288001b0a896c49a689ce">MTextProperty</a> *&nbsp;</td>
          <td class="paramname"> <em>prop</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Push a text property onto an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga1db069da9e058d3129a6469f4d359c0f" title="Push a text property onto an M-text.">mtext_push_property()</a> function pushes text property <b>prop</b> to the characters between <b>from</b> (inclusive) and <b>to</b> (exclusive) in M-text <b>mt</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga1db069da9e058d3129a6469f4d359c0f" title="Push a text property onto an M-text.">mtext_push_property()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga4830a8a120aeed2185d6da8fd2daa05e"></a><!-- doxytag: member="textprop.c::mtext_serialize" ref="ga4830a8a120aeed2185d6da8fd2daa05e" args="(MText *mt, int from, int to, MPlist *property_list)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* mtext_serialize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>property_list</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Serialize text properties in an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a> function serializes the text between <b>from</b> and <b>to</b> in M-text <b>mt</b>. The serialized result is an M-text in a form of XML. <b>property_list</b> limits the text properties to be serialized. Only those text properties whose key</p>
<ul>
<li>appears as the value of an element in <b>property_list</b>, and </li>
<li>has the symbol property <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735" title="Symbol for specifying serializer functions.">Mtext_prop_serializer</a></li>
</ul>
<p>are serialized as a "property" element in the resulting XML representation.</p>
<p>The DTD of the generated XML is as follows:</p>
<div class="fragment"><pre class="fragment">
&lt;!DOCTYPE mtext [
  &lt;!ELEMENT mtext (property*,body+)&gt;
  &lt;!ELEMENT property EMPTY&gt;
  &lt;!ELEMENT body (#PCDATA)&gt;
  &lt;!ATTLIST property key CDATA #REQUIRED&gt;
  &lt;!ATTLIST property value CDATA #REQUIRED&gt;
  &lt;!ATTLIST property from CDATA #REQUIRED&gt;
  &lt;!ATTLIST property to CDATA #REQUIRED&gt;
  &lt;!ATTLIST property control CDATA #REQUIRED&gt;
 ]&gt;
</pre></div><p>This function depends on the libxml2 library. If the m17n library is configured without libxml2, this function always fails.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a> returns an M-text in the form of XML. Otherwise it returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a>, <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735" title="Symbol for specifying serializer functions.">Mtext_prop_serializer</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga82e022961a26f82ddf580782a50d94bf"></a><!-- doxytag: member="textprop.c::mtext_deserialize" ref="ga82e022961a26f82ddf580782a50d94bf" args="(MText *mt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* mtext_deserialize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Deserialize text properties in an M-text. </p>
<p>The <a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a> function deserializes M-text <b>mt</b>. <b>mt</b> must be an XML having the following DTD.</p>
<div class="fragment"><pre class="fragment">
&lt;!DOCTYPE mtext [
  &lt;!ELEMENT mtext (property*,body+)&gt;
  &lt;!ELEMENT property EMPTY&gt;
  &lt;!ELEMENT body (#PCDATA)&gt;
  &lt;!ATTLIST property key CDATA #REQUIRED&gt;
  &lt;!ATTLIST property value CDATA #REQUIRED&gt;
  &lt;!ATTLIST property from CDATA #REQUIRED&gt;
  &lt;!ATTLIST property to CDATA #REQUIRED&gt;
  &lt;!ATTLIST property control CDATA #REQUIRED&gt;
 ]&gt;
</pre></div><p>This function depends on the libxml2 library. If the m17n library is configured without libxml2, this function always fail.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a> returns the resulting M-text. Otherwise it returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a>, <a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077" title="Symbol for specifying deserializer functions.">Mtext_prop_deserializer</a> </dd></dl>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga759ba1a6ac36d9847bc6b4d431ae3735"></a><!-- doxytag: member="textprop.c::Mtext_prop_serializer" ref="ga759ba1a6ac36d9847bc6b4d431ae3735" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735">Mtext_prop_serializer</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for specifying serializer functions. </p>
<p>To serialize a text property, the user must supply a serializer function for that text property. This is done by giving a symbol property whose key is <a class="el" href="group__m17nTextProperty.html#ga759ba1a6ac36d9847bc6b4d431ae3735" title="Symbol for specifying serializer functions.">Mtext_prop_serializer</a> and value is a pointer to an appropriate serializer function.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a>, <a class="el" href="group__m17nTextProperty.html#gaada4c814dbc5172e58c24a2aad6787d4" title="Type of serializer functions.">MTextPropSerializeFunc</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga97f4c75b4ebf8ff252948dbf068bc077"></a><!-- doxytag: member="textprop.c::Mtext_prop_deserializer" ref="ga97f4c75b4ebf8ff252948dbf068bc077" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077">Mtext_prop_deserializer</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for specifying deserializer functions. </p>
<p>To deserialize a text property, the user must supply a deserializer function for that text property. This is done by giving a symbol property whose key is <a class="el" href="group__m17nTextProperty.html#ga97f4c75b4ebf8ff252948dbf068bc077" title="Symbol for specifying deserializer functions.">Mtext_prop_deserializer</a> and value is a pointer to an appropriate deserializer function.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a>, <a class="el" href="group__m17nTextProperty.html#gaada4c814dbc5172e58c24a2aad6787d4" title="Type of serializer functions.">MTextPropSerializeFunc</a> </dd></dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
